/*
 * Copyright (C) 2014 Rolf Eike Beer <eike@sf-mail.de>
 */

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#pragma once

#include "controlwidget.h"

#include <marble/MarbleWidget.h>
#include <QHash>
#include <QString>

class QIODevice;
class QNetworkAccessManager;
class QNetworkReply;

class OSMNode;

class HydWidget: public Marble::MarbleWidget {
	Q_OBJECT
public:
	HydWidget(QWidget *parent = 0);
	virtual ~HydWidget();

	void loadDataForArea(qreal x0, qreal y0, qreal x1, qreal y1);

public slots:
	void slotDownloadDone(QNetworkReply *r);
	void reload(ControlWidget::NodeTypes types);

private:
	static const QString emg;
	static const QString amen;
	static const QString fh;
	static const QString wtank;

	void readData(QIODevice *r);

	QHash<qint64, OSMNode *> m_hyds;
	QMultiHash<QString, QString> m_filter;

	QNetworkAccessManager * const m_netmgr;
};
